]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame_incremental - rpm.macros
- kill _preserve_env recursion (every call to _clean_env was causing
[packages/rpm-build-macros.git] / rpm.macros
... / ...
CommitLineData
1# vim:ts=4 sw=4 noet ft=spec
2#
3# PLD Linux rpm macros.
4# <http://www.pld-linux.org/>
5
6# can be used by builder script to check for version
7%rpm_build_macros {Revision}
8
9%epoch 0
10%x8664 x86_64 amd64 ia32e
11%arm armv3l armv4b armv4l armv5teb armv5tel
12
13# kernel compiler
14%kgcc %{__cc}
15%kgcc_package gcc
16
17# compiler version
18%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion 2>/dev/null || echo 0.0)}%cc_version
19%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion 2>/dev/null || echo 0.0)}%cxx_version
20
21%__rm /bin/rm --interactive=never
22
23# Build system path macros.
24%__autoconf autoconf %{?debug:-Wall}
25%__automake automake -a -c -f --foreign
26%__autopoint autopoint --force
27
28# add parallel build flags: -jN
29# jobs macro is available since 1.657
30#
31# if you want to disable parallel build do:
32# echo '%__jobs %{nil}' >> ~/.rpmmacros
33%__jobs %{expand:%%global __jobs %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); [ "$_NCPUS" -gt 3 ] && echo $(($_NCPUS / 2)))%%{nil}}%__jobs
34
35# expands to -jN if %__jobs has a value
36%_smp_mflags %{expand:%%global _smp_mflags %(jobs=%{__jobs}; echo ${jobs:+-j$jobs}%%{nil})}%_smp_mflags
37
38%__make /usr/bin/make %{?_smp_mflags}
39%__scons /usr/bin/scons %{?_smp_mflags}
40%__waf /usr/bin/waf %{?_smp_mflags}
41%__cmake /usr/bin/cmake
42
43%__gettextize { \
44 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
45 gettextize --copy --force --no-changelog; \
46 else \
47 gettextize --copy --force --no-changelog --intl; \
48 fi; \
49 if [ ! -f po/Makevars ]; then \
50 cp -f po/Makevars{.template,}; \
51 fi; \
52}
53
54%__glib_gettextize glib-gettextize --copy --force
55%__gnome_doc_common gnome-doc-common --copy
56%__gnome_doc_prepare gnome-doc-prepare --copy --force
57%__gtkdocize gtkdocize --copy
58%__intltoolize intltoolize --copy --force
59%__libtoolize libtoolize --copy --force --install
60
61# topdir is where builder script lives,
62# fallback to old style if SPECS/SOURCES dirs were found.
63%_topdir %{expand:%%global _topdir %(
64 if [ -d SPECS -a -d SOURCES ]; then
65 # old style rpmdir: in topdir
66 pwd
67 elif [ -d ../SPECS -a -d ../SOURCES ]; then
68 # old style rpmdir: in subdir
69 cd ..; pwd
70 elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
71 # if old style rpm dir exist, go with it
72 echo $HOME/rpm; \
73 elif [ -x ../builder -a ! -d ../builder ]; then
74 # relative new style rpmdir: in package dir
75 cd ..; pwd
76 elif [ -x builder -a ! -d builder ]; then
77 # relative new style rpmdir: in packages
78 pwd
79 elif [ -x packages/builder -a ! -d packages/builder ]; then
80 # relative new style rpmdir: packages dir in current dir
81 cd packages; pwd
82 else
83 # fallback to new style rpmdir
84 echo $HOME/rpm/packages
85 fi; \
86)}%_topdir
87
88# if %{_topdir}/SPECS exists, it's old style structure
89%_specdir %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
90%_sourcedir %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
91
92# BUILD/RPMS/SRPMS are one same level by default as packages dir, if these exist
93# if they don't exist assume we are having custom topdir (which is not named as
94# "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
95# NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therfore the extra echo
96%_builddir %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
97%_rpmdir %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
98%_srcrpmdir %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
99
100# The number of cvs changelog entries kept when building package.
101%_buildchangelogtruncate 20
102
103%dependencytracking %{nil}
104
105# Relations between package names that cause dependency loops
106# with legacy packages that cannot be fixed. Relations are
107# specified as
108# p>q
109# where package p has a Requires: on something that package q Provides:
110#
111# XXX Note: that there cannot be any whitespace within the string "p>q",
112# and that both p and q are package names (i.e. no version/release).
113%_dependency_whiteout %{nil}
114
115#-----------------------------------------------------------------
116#
117# (re)definition of %{rpm*flags} with %filterout_* support
118# BuildRequires: awk
119# BuildRequires: rpmbuild(macros) >= 1.315
120#
121# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
122# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
123# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
124# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
125# %rpmldflags = %optldflags - %filterout_ld
126#
127# Regular expressions are supported, but to avoid some character be treated
128# as regular expression it must be escaped twice.
129
130%filter_out \
131 for (i = 1; i in I; i++) { A=0; \
132 for (f in F) { \
133 if (I[i] ~ "^" F[f] "$") A=1; \
134 }; \
135 if (!A) printf(I[i] FS); \
136 }
137
138%rpmcflags %(awk 'BEGIN {
139 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
140 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
141 %{filter_out}
142}')
143
144%rpmcxxflags %(awk 'BEGIN {
145 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
146 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
147 %{filter_out}
148}')
149
150%rpmcppflags %(awk 'BEGIN {
151 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
152 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
153 %{filter_out}
154}')
155
156%rpmldflags %(awk 'BEGIN {
157 split("%{?optldflags}",I);
158 split("%{?filterout_ld}",F)
159 %{filter_out}
160}')
161
162# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
163# but, don't use it, better use gcc as linker
164%ld_rpmldflags %(awk 'BEGIN {
165 split("%{rpmldflags}",F);
166 for (f in F) {
167 s = F[f];
168 if (s ~ /^-Wl,/) {
169 s = substr(s,5);
170 gsub(/,/," ",s);
171 };
172 printf(s FS);
173 };
174}')
175
176#-----------------------------------------------------------------
177#
178# Generate a command which cleans environment, leaving only the
179# most important variables.
180# If any spec requires any additional environment it should
181# redefine %_preserve_env in following manner:
182#
183# # ADDITIONAL_VAR is required because [a good reason here]
184# %define _preserve_env ADDITIONAL_VAR
185
186%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
187
188# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
189%_clean_env env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
190 split("%{?_preserve_env:%_preserve_env %_preserve_env_base}%{!?_preserve_env:%_preserve_env_base}", P);
191 for (i in P) {
192 p = P[i];
193 if (!ENVIRON[p] || d[p]) {
194 continue;
195 }
196 d[p] = 1;
197 split(ENVIRON[p], V, "");
198 val = p "=";
199 for (j = 1; j in V; j++) {
200 v = V[j];
201 if (v == q)
202 v = qq;
203 else if (v == "\\"")
204 v = q2q;
205 else if (v == "\\\\")
206 v = "\\\\\\\\";
207 else
208 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
209 val = val "" v;
210 }
211 printf(val " ");
212 }
213}')
214
215#-----------------------------------------------------------------
216%configure2_13 { \
217 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
218 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
219 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
220 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
221 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
222 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
223 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
224 %{?__cc:CC="%{__cc}" ; export CC ; } \
225 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
226 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
227 --host=%{_target_platform} \
228 --prefix=%{_prefix} \
229 --exec-prefix=%{_exec_prefix} \
230 --bindir=%{_bindir} \
231 --sbindir=%{_sbindir} \
232 --sysconfdir=%{_sysconfdir} \
233 --datadir=%{_datadir} \
234 --includedir=%{_includedir} \
235 --libdir=%{_libdir} \
236 --libexecdir=%{_libexecdir} \
237 --localstatedir=%{_localstatedir} \
238 --sharedstatedir=%{_sharedstatedir} \
239 --mandir=%{_mandir} \
240 --infodir=%{_infodir} \
241 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
242 %{dependencytracking} \
243}
244
245%cmake \
246%{?__cc:CC="%{__cc}"} \\\
247%{?__cxx:CXX="%{__cxx}"} \\\
248CPPFLAGS="${CPPFLAGS:-%{rpmcppflags}}" \\\
249%{__cmake} \\\
250 -DCMAKE_VERBOSE_MAKEFILE=ON \\\
251 -DCMAKE_BUILD_TYPE=%{!?debug:PLD}%{?debug:Debug} \\\
252 -DCMAKE_INSTALL_LIBDIR:PATH=%{_libdir} \\\
253 -DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} \\\
254 -DINCLUDE_INSTALL_DIR:PATH=%{_includedir} \\\
255 -DLIB_INSTALL_DIR:PATH=%{_libdir} \\\
256 -DSHARE_INSTALL_PREFIX:PATH=%{_datadir} \\\
257 -DSYSCONF_INSTALL_DIR:PATH=%{_sysconfdir} \\\
258 -DCMAKE_CXX_FLAGS_PLD="${CXXFLAGS:-%{rpmcxxflags} -DNDEBUG}" \\\
259 -DCMAKE_C_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG}" \\\
260 -DCMAKE_Fortran_FLAGS_PLD="${CFLAGS:-%{rpmcflags} -DNDEBUG}" \\\
261 -DCMAKE_EXE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
262 -DCMAKE_SHARED_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
263 -DCMAKE_MODULE_LINKER_FLAGS_PLD="${LDFLAGS:-%{rpmldflags}}" \\\
264%if "%{_lib}" == "lib64" \
265 -DLIB_SUFFIX=64 \\\
266%endif \
267 -DBUILD_SHARED_LIBS:BOOL=ON \\\
268%{nil}
269
270%scons { \
271%{__scons} \
272 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
273 CFLAGS="${CFLAGS:-%rpmcflags}" \
274 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
275 FFLAGS="${FFLAGS:-%rpmcflags}" \
276 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
277 %{?__cc:CC="%{__cc}"} \
278 %{?__cxx:CXX="%{__cxx}"} \
279 libsuffix=%{_lib} \
280 prefix=%{_prefix} \
281}
282
283# waf. see waf.spec
284%waf { \
285CC="%{__cc}" \
286CXX="%{__cxx}" \
287CPP="%{__cpp}" \
288CFLAGS="%{rpmcflags}" \
289CXXFLAGS="%{rpmcxxflags}" \
290%{__waf} \
291}
292
293#----------------------------------------------------------------
294#%configure_cache 0
295%configure_cache_file %{buildroot}.configure.cache
296
297%configure {./configure \
298 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
299 CFLAGS="${CFLAGS:-%rpmcflags}" \
300 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
301 FFLAGS="${FFLAGS:-%rpmcflags}" \
302 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
303 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
304 %{?__cc:CC="%{__cc}"} \
305 %{?__cxx:CXX="%{__cxx}"} \
306 --host=%{_target_platform} \
307 --build=%{_target_platform} \
308 --prefix=%{_prefix} \
309 --exec-prefix=%{_exec_prefix} \
310 --bindir=%{_bindir} \
311 --sbindir=%{_sbindir} \
312 --sysconfdir=%{_sysconfdir} \
313 --datadir=%{_datadir} \
314 --includedir=%{_includedir} \
315 --libdir=%{_libdir} \
316 --libexecdir=%{_libexecdir} \
317 --localstatedir=%{_localstatedir} \
318 --sharedstatedir=%{_sharedstatedir} \
319 --mandir=%{_mandir} \
320 --infodir=%{_infodir} \
321 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
322 %{dependencytracking} \
323 %{?configure_cache:--cache-file=%{configure_cache_file}} \
324}
325
326# Simple macros to simplify adding bconded options to configure scripts.
327# Each macro requires bcond name and accepts optional option name, if option
328# isn't specified bcond name is used as option name. Options returning
329# --with and --enable also allow third argument which will be added as value
330# ( --with-option=value or --enable-option=value ) in case or positive
331# condition, but won't be added otherwise ( nothing or just --disable-option ).
332
333# Requirements:
334# BuildRequires: rpmbuild(macros) >= 1.527
335
336# Usage example:
337# %{__enable bcond} - returns --enable-bcond iff build condition is set
338# %{__disable bcond option} - returns --enable-option iff bcond is not set
339# %{__enable_disable bcond option value} - returns --enable-option=value if
340# bcond is set, returns --disable-option otherwise
341
342# expand bconds to --enable-something and --disable-something
343%__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
344%__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
345%__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
346
347# same as above, but condition inverted
348%__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
349%__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
350%__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
351
352# expand bconds to --with-something and --without-something
353%__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
354%__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
355%__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
356
357# same as above, but condition inverted
358%__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
359%__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
360%__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
361
362#-----------------------------------------------------------------
363
364# overload to insert debuginfo package
365%prep \
366%if 0%{?_enable_debug_packages}\
367%{debug_package}\
368%endif\
369%%prep\
370%{nil}
371
372# Location of autoconf macros
373%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir 2>/dev/null || echo ERROR)}%_aclocaldir
374
375# Location of omf files
376%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
377
378# Location of pkgconfig files
379%_pkgconfigdir /usr/%{_lib}/pkgconfig
380# noarch pkgconfig files
381%_npkgconfigdir /usr/share/pkgconfig
382
383# Location of desktop files
384%_desktopdir /usr/share/applications
385%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
386
387# Location of pixmaps for applnk/desktop files
388%_pixmapsdir /usr/share/pixmaps
389
390# Location of themable icons for applnk/desktop files
391%_iconsdir /usr/share/icons
392
393# Location of fonts directories
394%_fontsdir /usr/share/fonts
395
396# Location of Gtk and associated libraries documentation
397%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
398
399# Location of KDE documentation
400%_kdedocdir %{_defaultdocdir}/kde/HTML
401
402# unsermake script
403%__unsermake /usr/share/unsermake/unsermake
404
405# Current date
406%date %(LC_ALL=C date +"%a %b %d %Y")
407
408# Example files, programs, scripts...
409%_examplesdir /usr/src/examples
410
411# Alternative kernel type/version
412%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
413
414# The directory holding Linux kernel sources
415%_kernelsrcdir /usr/src/linux%{_alt_kernel}
416
417# SysV-style initscripts dir
418%_initddir /etc/rc.d/init.d
419
420# If non-empty "debug" macro defined, add "dbg" suffix to release number
421%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
422
423# Bootstrap release macros.
424# Usage:
425# %bcond_with bootstrap
426# Release: %{bootstrap_release 1}
427#
428# Package will have release 1 if built normally,
429# and release 0.zzz.bootstrap if built with bootstrap
430%bootstrap_release() %{!?with_bootstrap:%{1}%{?2:.%{2}}}%{?with_bootstrap:%{!?2:%(expr %{1} - 1)}%{?2:%{1}.%(expr %{2} - 1)}.zzz.bootstrap}
431
432# rpm -qf on kernel version.h file
433%__kernel_qf() %(R=$(cd %{_kernelsrcdir} 2>/dev/null && LC_ALL=C rpm -q --qf '%*' -f include/linux/version.h 2>/dev/null | grep -v 'is not'); echo ${R:-ERROR})
434
435# kernel %{name} and kernel %{epoch}:%{version}-%{release} macro respecing alt_kernel
436%kernel_name %{expand:%%global kernel_name %(N=%{__kernel_qf %{N}};echo ${N%%-headers})}%kernel_name
437%kernel_version %{expand:%%global kernel_version %{__kernel_qf %|E?{%{E}:}|%{V}-%{R}}}%kernel_version
438
439# -n drm to generate kernel%{_alt_kernel}-drm dependency
440%releq_kernel(n:) %{kernel_name}%{?-n:-%{-n*}} = %{kernel_version}
441%releq_kernel_up(n:) %{kernel_name}-up%{?-n:-%{-n*}} = %{kernel_version}
442%releq_kernel_smp(n:) %{kernel_name}-smp%{?-n:-%{-n*}} = %{kernel_version}
443
444# -s post to generate Requires(post) dependency
445%requires_releq_kernel(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel
446%requires_releq_kernel_up(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_up
447%requires_releq_kernel_smp(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
448
449# Requires name = version-release
450%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
451# Requires: name = version
452%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
453# Requires: name = version (version based on querying package %2)
454%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
455
456# Requires: name >= version
457%requires_ge() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_ge_to %1 %1}}}
458# Requires: name >= version (version based on querying package %2)
459%requires_ge_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 >= %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
460
461# \helper for renaming packages
462# %rename old-package
463%rename() \
464Obsoletes: %{1} < %{?epoch:%{epoch}:}%{?version:%{version}}%{?release:-%{release}} \
465Provides: %{1} = %{?epoch:%{epoch}:}%{?version:%{version}}%{?release:-%{release}}
466
467%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
468
469# kernel version-release handling
470%__kernel_ver %{expand:%%global __kernel_ver %( \\
471 Z=$([ -f '%{_kernelsrcdir}/include/generated/utsrelease.h' ] && awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/{linux/version,generated/utsrelease}.h 2>/dev/null || awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
472 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
473 echo ${Z:-ERROR}; \\
474)}%__kernel_ver
475
476%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(cd %{_kernelsrcdir} 2>/dev/null && LC_ALL=C rpm -qf include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
477%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(cd %{_kernelsrcdir} 2>/dev/null && LC_ALL=C rpm -qf include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
478%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
479%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
480
481# `uname -r` to be used in @release field
482%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
483
484# sgml macros
485%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
486%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
487%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
488%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
489%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
490%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
491%docbook_sgmlcat_fix() { for l in \
492'' \
493' -- default decl --' \
494'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
495' -- hacks for opensp --' \
496'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
497'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
498'' \
499; do echo $l; done >> %1 \
500}
501
502# vim - "
503
504# minimum file size needed for compressed documents.
505# just smaller files than this get larger when compressed.
506# some stats:
507# - 0 byte file compressed was 25 bytes .gz
508# - 39 byte file was compressed as 57
509# - with test/test.spec@man 158 byte file was compressed also 158
510%_min_compress_bytes 159
511
512#-----------------------------------------------------------------
513# find and gzip all files in %{_mandir} and %{infodir}
514#
515# Requires: xargs, find
516#
517#%no_install_post_compress_docs 1
518%__spec_install_post_compress_docs { \
519%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
520 %{!?debug:set +x;} \
521 for i in /usr/share/man /usr/X11R6/man; do \
522 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
523 echo "Compress man pages: $i"; \
524 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
525 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
526 find $RPM_BUILD_ROOT$i -type l | while read a; do \
527 m=$(readlink "$a"); \
528 if [[ "$m" = */* ]]; then \
529 # handle links to different man section \
530 l=$(readlink -f "$a"); \
531 # full/relative paths that resolve symlink \
532 l=${l#$RPM_BUILD_ROOT/usr/share/man/}; \
533 l=${l#$RPM_BUILD_ROOT/usr/X11R6/man/}; \
534 # full paths that do not resolve symlink \
535 l=${l#/usr/share/man/}; \
536 l=${l#/usr/X11R6/man/}; \
537 else \
538 l=${a#$RPM_BUILD_ROOT$i/}; \
539 l=${l%/*}; \
540 l="$l/$m"; \
541 fi; \
542 rm -f $a; \
543 echo ".so $l" > $a; \
544 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: $l"; \
545 done; \
546 # verify that .so links point to existing files (not allowed to point to "other package") \
547 # TODO: iterate over all man dirs, but in Th there is only one true man dir \
548 err=$(grep -rl '^\.so ' "$RPM_BUILD_ROOT$i" | while read doc; do \
549 l=$(cat "$doc"); \
550 l=${l#.so }; \
551 d=$(dirname $doc); \
552 test -e $RPM_BUILD_ROOT$i/$l || test -e $d/$l || echo " ${doc#$RPM_BUILD_ROOT} points to inexistent manpage: $l"; \
553 done); \
554 test "$err" != "" && { echo >&2 "Man page link errors:"; echo >&2 "$err"; exit 1; }; \
555 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
556 fi; \
557 done; \
558 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
559 echo "Compress info pages: %{_infodir}"; \
560 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
561 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
562 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
563 fi; \
564}; __spec_install_post_compress_docs } }
565
566#-----------------------------------------------------------------
567# Strip executable binaries and shared object files
568#
569# Requires: find, awk, strip, cut, xargs
570#
571# Special macros which affect this process:
572#%no_install_post_strip 1 # disable stripping at all
573#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
574#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
575#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
576#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
577#
578%__spec_install_post_strip {%{!?debug: \
579%{!?no_install_post_strip:__spec_install_post_strip() { \
580%{!?debug:set +x;} \
581if [ -d "$RPM_BUILD_ROOT" ]; then \
582 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
583 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
584 if [ "$modulelist" ]; then \
585 modulecount=$(echo "$modulelist" | wc -l); \
586 printf "Stripping %d kernel modules..." $modulecount; \
587 echo "$modulelist" | xargs -l512 chmod u+w; \
588 echo "$modulelist" | xargs -l512 %{__strip} -g --remove-section=.comment --remove-section=.note.GNU-stack; \
589 echo "DONE"; \
590 fi; \
591 fi; \
592 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
593 if [ -n "$filelist" ]; then \
594 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
595 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
596 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
597 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
598 if [ -n "$elfexelist" ]; then \
599 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
600 echo "$elfexelist" | xargs -r -d'\n' chmod u+w; \
601 echo "$elfexelist" | xargs -r -d'\n' %{__strip} --remove-section=.note --remove-section=.comment; \
602 echo "DONE"; \
603 fi; \
604 if [ -n "$elfsharedlist" ]; then \
605 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
606 echo "$elfsharedlist" | xargs -r -d'\n' chmod u+w; \
607 echo "$elfsharedlist" | xargs -r -d'\n' %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment; \
608 echo "DONE"; \
609 fi; \
610 if [ -n "$archiveslist" ]; then \
611 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
612 echo "$archiveslist" | xargs -r -d'\n' chmod u+w; \
613 echo "$archiveslist" | xargs -r -d'\n' %{__strip} --strip-debug --remove-section=.note --remove-section=.comment; \
614 echo "DONE"; \
615 fi; \
616 fi; \
617 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
618 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
619 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
620 if [ -n "$filelist_all" ]; then \
621 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
622 chmod u+w $filelist_all; \
623 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
624 echo "DONE"; \
625 fi; \
626 if [ -n "$filelist_unneeded" ]; then \
627 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
628 chmod u+w $filelist_unneeded; \
629 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
630 echo "DONE"; \
631 fi; \
632 if [ -n "$filelist_debug" ]; then \
633 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
634 chmod u+w $filelist_debug; \
635 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
636 echo "DONE"; \
637 fi; \
638fi; }; __spec_install_post_strip } } }
639
640#-----------------------------------------------------------------
641# remove all RPATH/RUNPATH from executable binaries and shared object files
642#
643# Requires: find, awk, cut, xargs, chrpath, uname
644#
645# Special macros which affect this process
646#%no_install_post_chrpath 1 # disable chrpath at all
647#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
648#
649%__spec_install_post_chrpath {%{!?debug: \
650%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
651%{!?debug:set +x;} \
652if [ -d "$RPM_BUILD_ROOT" ]; then \
653 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
654 if [ -n "$files" ]; then \
655 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
656 fi; \
657 if [ -n "$objs" ]; then \
658 printf "Remove RPATH/RUNPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
659 echo "$objs" | \
660 while read file; do \
661 rpath= ; \
662 chmod u+w "$file"; \
663 for dir in $(chrpath -l "$file" | awk '/(R|RUN)PATH=/ { gsub(/.*RPATH=/,""); gsub(/.*RUNPATH=/,""); gsub(/:/," "); print $0 }'); do \
664 case $dir in \
665 '$ORIGIN' ) \
666 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
667 else rpath="$rpath:$dir" ; fi ; \
668 continue ; \
669 ;; \
670 esac ; \
671 newdir=$(readlink -m "$dir"); \
672 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
673 case $dir in \
674 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
675 echo "remove-rpath: $dir in $file"; \
676 ;; \
677 * ) \
678 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
679 else rpath="$rpath:$dir" ; fi ; \
680 ;; \
681 esac ; \
682 done ; \
683 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
684 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
685 done; \
686 fi; \
687fi; }; __spec_install_post_chrpath } } }
688
689# vim: "
690
691#-----------------------------------------------------------------
692# Find all shared object files with unresolved symbols. Warn
693# and terminate if any found (termination can be turned off by define).
694#%no_install_post_check_so 1
695#%skip_post_check_so libwithunresolvedok.so.*
696#
697# NOTE: define skip_post_check_so only if such library really requires
698# unresolved symbols and always leave a comment why it is required:
699# # executable provides symbols foo, bar for those libraries:
700# %define skip_post_check_so libwithoutfoo.so.* libwithoutbar.so.*
701#
702%__spec_install_post_check_so { \
703__spec_install_post_check_so() { \
704%{!?debug:set +x;} \
705 fail=0; \
706 printf "Searching for shared objects with unresolved symbols..."; \
707 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
708 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; %{?skip_post_check_so:split("%{skip_post_check_so}", R); for (i=1; i in R; i++) { if (file ~ "(^|/)" R[i] "$") { print "Library marked with skip_post_check_so, ignoring errors.\n"; exit(0); } } } exit(1); } } ' || fail=1 ; \
709 done ; \
710 echo " DONE"; \
711 %{!?no_install_post_check_so:return $fail;} \
712}; __spec_install_post_check_so }}
713
714#-----------------------------------------------------------------
715# Verify that for each directory under /var/run package contains
716# tmpfiles.d configuration. Warn and terminate build if config is
717# missing.
718#
719#%no_install_post_check_tmpfiles 1
720#
721%__spec_install_post_check_tmpfiles { \
722__spec_install_post_check_tmpfiles() { \
723%{!?debug:set +x;} \
724 fail=0; \
725 echo "Checking /var/run <-> tmpfiles.d completeness..."; \
726 for d in $RPM_BUILD_ROOT/var/run/*; do \
727 [ -d "$d" ] || continue; \
728 d=${d##$RPM_BUILD_ROOT}; \
729 if ! grep -qsF "$d" $RPM_BUILD_ROOT/usr/lib/tmpfiles.d/*.conf $RPM_BUILD_ROOT/etc/tmpfiles.d/*.conf; then\
730 echo "No tmpfiles configuration for '$d'";\
731 fail=1 ; \
732 fi \
733 done ; \
734 echo " DONE"; \
735 %{!?no_install_post_check_tmpfiles:return $fail;} \
736}; __spec_install_post_check_tmpfiles }}
737
738#-----------------------------------------------------------------
739# Find and gzip all kernel modules
740#
741# Requires: find
742#
743#%no_install_post_compress_modules 1
744%__spec_install_post_compress_modules { \
745%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
746%{!?debug:set +x;} \
747 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
748 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
749 if [ "$q" ]; then \
750 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
751 echo "$q" | xargs -r %{__gzip} -9nf; \
752 echo "DONE"; \
753 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
754 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
755 fi; \
756 fi; \
757}; __spec_install_post_compress_modules } }
758
759# Remove common Perl files we don't package
760%__spec_install_post_perl_clean {\
761%{!?no_install_post_perl_clean: \
762%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
763} }
764
765#-----------------------------------------------------------------
766# Update GConf2 schemas
767#
768# Requires: GConf2
769#
770%gconf_schema_install() \
771 umask 022; \
772 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
773 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
774%{nil}
775
776%gconf_schema_uninstall() \
777if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
778 umask 022; \
779 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
780 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
781fi; \
782%{nil}
783
784#-----------------------------------------------------------------
785# Update desktop MIME database
786# requires: desktop-file-utils
787%update_desktop_database() {{ \
788 umask 022; \
789 /usr/bin/update-desktop-database -q; \
790};} \
791%{nil}
792
793%update_desktop_database_post %update_desktop_database
794
795%update_desktop_database_postun() {{ \
796if [ "$1" = "0" ]; then \
797 %update_desktop_database \
798fi; \
799};} \
800%{nil}
801
802#-----------------------------------------------------------------
803# Update shared MIME info database
804# requires: shared-mime-info
805#
806%update_mime_database() {{ \
807 umask 022; \
808 /usr/bin/update-mime-database %{_datadir}/mime; \
809};} \
810%{nil}
811
812#-----------------------------------------------------------------
813# Update icon cache
814# BuildRequires: rpmbuild(macros) >= 1.596
815# Requires: hicolor-icon-theme
816#
817%update_icon_cache() {{ \
818 %{!?1:%{error:%{0}: Required theme name missing}} \
819 if [ -x /usr/bin/gtk-update-icon-cache ]; then \
820 umask 022; \
821 touch --no-create %{_iconsdir}/%1; \
822 /usr/bin/gtk-update-icon-cache -qf %{_iconsdir}/%1; \
823 fi; \
824};} \
825%{nil}
826
827#-----------------------------------------------------------------
828# Update scrollkeeper database
829# requires: scrollkeeper
830#
831%scrollkeeper_update_post() \
832 /usr/bin/scrollkeeper-update -q; \
833%{nil}
834
835%scrollkeeper_update_postun() \
836if [ "$1" = "0" ]; then \
837 /usr/bin/scrollkeeper-update -q; \
838fi; \
839%{nil}
840
841#-----------------------------------------------------------------
842# Compile GSettings schemas
843# requires: glib2 >= 1:2.26.0
844#
845%glib_compile_schemas() {{ \
846 umask 022; \
847 /usr/bin/glib-compile-schemas %{_datadir}/glib-2.0/schemas; \
848};} \
849%{nil}
850
851#-----------------------------------------------------------------
852# post %install sequence:
853# - autodeps exceptions
854# - compress all man and info pages,
855# - strip all ELF executables and ELF shared objects if not %debug.
856# - compress kernel modules if any
857
858###################################################################
859# Requires/Provides automation
860# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
861#
862%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
863%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
864%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
865%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
866%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq) \
867 %{?_noautoreq: %{_noautoreq}} \
868 %{?_noautoreq_pear: %{__noauto_regexp_helper -p pear %{_noautoreq_pear}}} \
869 %{?_noautoreq_perl: %{__noauto_regexp_helper -p perl %{_noautoreq_perl}}} \
870 %{nil}
871
872# helper for wrapping _noautoreq between perl() or pear()
873# Author: Elan Ruusamäe <glen@pld-linux.org>
874# Usage:
875# BuildRequires: rpmbuild(macros) >= 1.654
876# %define _noautoreq_pear Excluded.php PEAR/Something.php
877# %define _noautoreq_perl Apache::.*
878%__noauto_regexp_helper(p:) %(echo "%*" | awk 'BEGIN{RS=" "}{printf("%{-p*}\\\\\\(%%s\\\\\\) ", $1)}')
879
880#%_noautocompressdoc %{nil}
881#
882%_missing_doc_files_terminate_build 1%{nil}
883%_unpackaged_files_terminate_build %{nil}
884# (X)emacs support
885%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
886%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
887%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
888
889%__php_provides %{nil}
890%__php_requires %{nil}
891%__perl_provides %{nil}
892%__perl_requires %{nil}
893%__mono_provides %{nil}
894%__mono_requires %{nil}
895
896# Perl specific macro definitions.
897%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
898%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
899%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
900%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
901%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
902%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
903
904# Ruby
905%__ruby /usr/bin/ruby
906
907%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
908%ruby_libdir %{expand:%%global ruby_libdir %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_libdir
909%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
910%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
911%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
912%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
913%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
914%ruby_sitedir %{expand:%%global ruby_sitedir %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["sitedir"]' 2>/dev/null || echo ERROR)}%ruby_sitedir
915%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
916%ruby_rdocdir /usr/share/rdoc
917%ruby_vendordir %{expand:%%global ruby_vendordir %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["vendordir"]' 2>/dev/null || echo ERROR)}%ruby_vendordir
918%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
919
920%ruby_gemdir %{expand:%%global ruby_gemdir %(%{__ruby} -r rbconfig -e 'print RbConfig::CONFIG["rubylibdir"].sub(RbConfig::CONFIG["ruby_version"], "gems/#{RbConfig::CONFIG["ruby_version"]}")' 2>/dev/null || echo ERROR)}%{ruby_gemdir}
921%ruby_specdir %{ruby_gemdir}/specifications
922
923# deprecated, similar functionality autogenerated with rpm5
924%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
925%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
926
927%php_pear_dir /usr/share/pear
928%php_data_dir /usr/share/php
929%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
930%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
931%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
932
933# extract php/zend api versions
934%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
935%php_minor_version %{expand:%%global php_minor_version %(awk '/#define PHP_MINOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_minor_version
936%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
937%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
938%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
939%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
940%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
941%_zend_zts %{expand:%%global _zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%_zend_zts
942# "_ts" if ZTS enabled, empty otherwise
943%zend_zts %{expand:%%global _zend_zts_%{?_zend_zts} 1}%{?_zend_zts_1:_ts}
944
945# name of php package
946%php_name php%{?php_suffix}
947# use rpmbuild -D 'php_suffix 54' to build php extension for php 5.4
948# NOTE: error output must be empty. otherwise can't build pecl packages if no php*-devel is installed
949%php_suffix %{expand:%%global php_suffix %(c=$(php-config --sysconfdir 2>/dev/null) || echo '' && echo ${c#/etc/php})%%{nil}}%php_suffix
950
951# php cli. version that php headers are installed for
952%__php /usr/bin/%{php_name}
953
954# helper macro
955%__php_api_requires(v:) Requires: %{php_name}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
956
957# macros for public use
958# for php extensions (php-pecl)
959%requires_php_extension %{__php_api_requires modules_api php_api_version} \
960%{__php_api_requires zend_module_api} \
961%{__php_api_requires debug php_debug} \
962%{__php_api_requires thread-safety _zend_zts}
963
964# for zend extensions
965%requires_zend_extension %{__php_api_requires zend_module_api} \
966%{__php_api_requires zend_extension_api} \
967%{__php_api_requires debug php_debug} \
968%{__php_api_requires thread-safety _zend_zts}
969
970# for php pdo modules (php-pecl-PDO_*)
971%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
972
973# for using PHP post scripts. for PHP >= 5.0
974%php_webserver_restart \
975[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
976[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
977if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
978 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
979 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
980 %service -q php-fcgi restart \
981 fi \
982fi \
983if [ -x /etc/rc.d/init.d/%{php_name}-fpm ]; then \
984 %service -q %{php_name}-fpm restart \
985fi \
986%{nil}
987
988# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
989%php4_webserver_restart \
990[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
991[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
992if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
993 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
994 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
995 %service -q php-fcgi restart \
996 fi \
997fi \
998%{nil}
999
1000# X.org helper macros
1001%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
1002%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
1003
1004%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
1005%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
1006%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
1007%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
1008%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
1009# vim: '
1010
1011%requires_xorg_xserver_extension \
1012%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1013%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1014%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
1015%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
1016%{nil}
1017
1018%requires_xorg_xserver_xinput \
1019%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1020%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1021%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
1022%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
1023%{nil}
1024
1025%requires_xorg_xserver_font \
1026%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1027%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1028%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
1029%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
1030%{nil}
1031
1032%requires_xorg_xserver_videodrv \
1033%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
1034%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
1035%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
1036%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
1037%{nil}
1038
1039# TCL specific macro definitions.
1040# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
1041%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
1042%tcl_sitearch %{_libdir}/tcl%{tcl_version}
1043%tcl_sitelib %{_datadir}/tcl%{tcl_version}
1044
1045# Python specific macro definitions.
1046# python main version
1047%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
1048
1049# directories
1050%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
1051%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
1052%py_scriptdir %{py_prefix}/share/python%{py_ver}
1053%py_incdir /usr/include/python%{py_ver}
1054%py_sitedir %{py_libdir}/site-packages
1055%py_sitescriptdir %{py_scriptdir}/site-packages
1056%py_dyndir %{py_libdir}/lib-dynload
1057
1058# pure python modules compilation
1059%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1060
1061%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1062
1063# Software written in Python language require Python with main version
1064%pyrequires_eq() Requires: %1
1065
1066# Python 3.x
1067# python main version
1068%__python3 python3
1069%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
1070
1071# directories
1072%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
1073%py3_libdir %{expand:%%global py3_libdir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('platstdlib'))" 2>/dev/null || echo ERROR)}%py3_libdir
1074%py3_incdir %{expand:%%global py3_incdir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('include'))" 2>/dev/null || echo ERROR)}%py3_incdir
1075%py3_sitedir %{expand:%%global py3_sitedir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('platlib'))" 2>/dev/null || echo ERROR)}%py3_sitedir
1076%py3_sitescriptdir %{expand:%%global py3_sitescriptdir %(%{__python3} -c "import sysconfig; print(sysconfig.get_path('purelib'))" 2>/dev/null || echo ERROR)}%py3_sitescriptdir
1077%py3_scriptdir %{py3_prefix}/share/python%{py3_ver}
1078%py3_dyndir %{py3_libdir}/lib-dynload
1079
1080# pure python modules compilation
1081%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1082
1083%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
1084
1085# node.js libdir
1086# Requirements:
1087# BuildRequires: rpmbuild(macros) >= 1.634
1088%nodejs_libdir /usr/lib/node_modules
1089
1090# Hardlink binary identical .pyc and .pyo files
1091%__spec_install_post_py_hardlink {\
1092%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
1093%{!?debug:set +x;} \
1094local a b c=0 t=0 pyc=%{tmpdir}/%{name}-%{version}-%{release}__rpm_pyc; \
1095if [ -d "$RPM_BUILD_ROOT" ]; then \
1096 find "$RPM_BUILD_ROOT" -name '*.pyc' > $pyc; \
1097 while read a; do \
1098 b="${a%.pyc}.pyo"; \
1099 if cmp -s "$a" "$b"; then \
1100 ln -f "$a" "$b"; \
1101 c=$((c + 1)); \
1102 fi; \
1103 t=$((t + 1)); \
1104 done < $pyc; \
1105 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
1106 rm -f $pyc; \
1107fi; \
1108}; __spec_install_post_py_hardlink } }
1109
1110# Remove Python 2.x sources,
1111# PLD Linux policy is to package only compiled .py[co] for Python 2.x libraries.
1112# Author: Elan Ruusamäe <glen@pld-linux.org>
1113#
1114# Usage:
1115# %py_postclean /usr/share/extra -x keepme.py,keeptoo.py
1116# Options:
1117# -x - comma separated of file basenames to preserve
1118# ARGS - extra directories to clean for .py sources
1119#
1120%py_postclean(x:) \
1121for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
1122 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 %{-x:| grep -ZzvE '/(%(echo '%{-x*}' | tr ',' '|'))$'} | xargs -0r -l512 rm;\
1123done \
1124%{nil}
1125
1126# depmod macro
1127%depmod() { \
1128umask 022; \
1129if [ -e /boot/System.map-%1 ]; then \
1130 /sbin/depmod -a -F /boot/System.map-%1 %1; \
1131else \
1132 if [ -e /boot/System.map ]; then \
1133 /sbin/depmod -a -F /boot/System.map %1; \
1134 else \
1135 /sbin/depmod -a %1; \
1136 fi \
1137fi; \
1138}
1139
1140# XMMS specific macros
1141%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
1142%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
1143%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
1144%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
1145%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
1146%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
1147%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
1148%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
1149%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
1150%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
1151
1152%_host_base_arch %{expand:%%global _host_base_arch %(echo %{_host_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/;s/arm.*/arm/')}%_host_base_arch
1153%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/;s/arm.*/arm/')}%_target_base_arch
1154
1155# user/group checking macros
1156#
1157# Usage:
1158# %userremove myuser
1159#
1160%userremove /usr/lib/rpm/user_group.sh user del
1161%groupremove /usr/lib/rpm/user_group.sh group del
1162#
1163# Usage:
1164# if %usertestrm myuser; then
1165# /usr/sbin/userdel -r myuser
1166# Note:
1167# use these macros only if you need to call userdel/groupdel with
1168# a non-standard option or take an extra action; otherwise use the
1169# %userremove/%groupremove macros
1170#
1171%usertestrm /usr/lib/rpm/user_group.sh user testrm
1172%grouptestrm /usr/lib/rpm/user_group.sh group testrm
1173# user group membership management macros
1174#
1175# Usage:
1176# %addusertogroup [-q] myuser agroup
1177#
1178# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1179#
1180# Requirements:
1181# BuildRequires: rpmbuild(macros) >= 1.515
1182%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1183%{nil}
1184
1185# banner support (useful in {pre,post}{,un} and triggers)
1186#
1187# Usage:
1188# %banner name [-a] [-e] [-n] [-tn] [-o] <<EOF
1189# the banner text, the banner text
1190# the banner text, and following line
1191#EOF
1192# You can use any form of here-document, <<'EOF' <<-EOT will do.
1193# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1194#
1195# -a - append to the banner
1196# -e - send to stderr instead of stdout
1197# -n - no show banner (overrides -t)
1198# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
1199# -o - show only once, i.e when package is installed for the first time
1200#
1201# Tests:
1202# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1203# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1204# (rpm -E '%banner -o -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m 1
1205# rpm -E 'date | %banner -e banner' > m; sh -x m
1206# rpm -E 'date | %banner -o -e banner' > m; sh -x m
1207#
1208%banner(aenot:) %{-o:([ "$1" != 1 ] ||} ( \
1209RPM_SCRIPTVERBOSITY=5 \
1210[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1211if [ -x /usr/bin/banner.sh ]; then \
1212 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1213else \
1214 CMD="cat%{-e: >&2}" \
1215fi \
1216eval $CMD %{?2:%2}%{?3: %3})%{-o:)} \
1217%{nil}
1218
1219# useradd/groupadd macros
1220# Author: Elan Ruusamäe <glen@pld-linux.org>
1221#
1222# Usage:
1223# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1224# [-g initial_group] [-G group[,...]] login
1225#
1226# -u uid. REQUIRED
1227# -g gid/group. REQUIRED
1228# -s defaults to /bin/false
1229# -d defaults to /usr/share/empty
1230# -c No default
1231# -r is accepted but ignored (it's always set)
1232# -k skeleton dir. defaults to /usr/share/empty
1233# rpm specific flags
1234# -P package name. defaults to %{name}
1235#
1236%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
1237%{!-u:%{error:useradd: Required argument -u missing}} \
1238%{!-g:%{error:useradd: Required argument -g missing}} \
1239%{!?1:%{error:useradd: Required parameter login missing}} \
1240if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1241 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1242 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1243 exit 1 \
1244 fi \
1245else \
1246 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1247 /usr/sbin/useradd \\\
1248 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
1249 -u %{-u*} \\\
1250 -r \\\
1251 -d %{-d*}%{!-d:/usr/share/empty} \\\
1252 -s %{-s*}%{!-s:/bin/false} \\\
1253 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
1254 -g %{-g*} \\\
1255 %{-M} \\\
1256 %{-G:-G %{-G*}} \\\
1257 %{expand:%{%{#}}} 1>&2 || exit $? \
1258 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
1259fi;
1260# vim: "
1261
1262# Usage:
1263# %groupadd [-P package] [-g gid] group
1264#
1265# -g gid. REQUIRED
1266#
1267# Sample:
1268# %groupadd -P %{name}-base -g %{gid} %{name}
1269
1270%groupadd(g:P:rfo) \
1271%{!-g:%{error:groupadd: Required argument -g missing}} \
1272%{!?1:%{error:groupadd: Required parameter group missing}} \
1273if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
1274 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1275 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1276 exit 1 \
1277 fi \
1278else \
1279 echo "Adding group %{1} GID=%{-g*}." \
1280 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
1281 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
1282fi;
1283
1284# webapp macros
1285# Author: Elan Ruusamäe <glen@pld-linux.org>
1286#
1287# The config is installed/removed inside trigger, this means that you can any
1288# time install apache1/apache/lighttpd package and the configuration file is
1289# updated. if you don't need the config for various reason for specific
1290# webserver, just remove the symlink from config directory using webapp
1291# program. the trigger will not recreate the symlink on upgrades. In other
1292# words the config is linked to webserver config directory on first install of
1293# PACKAGE or WEBSERVER.
1294#
1295# Add package's webserver config to webserver webapps dir.
1296# Usage:
1297# %webapp_register [-f] WEBSERVER WEBAPP
1298#
1299%webapp_register(f) \
1300%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
1301if [ -n "%{-f:1}" ] || [ "$1" = "1" ] && [ "$2" = "1" ]; then\
1302 /usr/sbin/webapp register %1 %2\
1303fi\
1304# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
1305if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
1306 %{expand:%service -q %%1 reload}\
1307fi\
1308%{nil}
1309
1310# Remove package's config from webserver webapps dir.
1311# Usage:
1312# %webapp_register [-f] WEBSERVER WEBAPP
1313%webapp_unregister(f) \
1314%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1315# remove link if either of the packages are gone \
1316if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
1317 /usr/sbin/webapp unregister %1 %2\
1318 %{expand:%service -q %%1 reload}\
1319fi \
1320%{nil}
1321
1322# service macro.
1323# Author: Elan Ruusamäe <glen@pld-linux.org>
1324#
1325# calls usual service restart on package %post, but skips the restart if
1326# administrator has disabled automatic service restarts in either global
1327# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1328#
1329# Usage:
1330# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
1331#
1332# -q be silent when service isn't started (for scriplets restaring other package's services)
1333# -n NOOP mode, do not actually restart service
1334#
1335# Requirements:
1336# BuildRequires: rpmbuild(macros) >= 1.268
1337# Requires: rc-scripts
1338# -n option:
1339# BuildRequires: rpmbuild(macros) >= 1.450
1340%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1} RPM_BUILD_ROOT=%{buildroot}; /usr/lib/rpm/service_generator.sh %{*}) };}
1341
1342# Java macros. based on jpackage macros.java
1343#
1344# Root directory where all Java VMs/SDK/JREs are installed.
1345%_jvmdir %{_libdir}/jvm
1346
1347# Root directory where all Java VMs/SDK/JREs expose their jars
1348%_jvmjardir %{_libdir}/jvm-exports
1349
1350# Root directory for all Java VM/SDK/JRE's private things.
1351%_jvmprivdir %{_libdir}/jvm-private
1352
1353# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
1354%_jvmlibdir %{_libdir}/jvm
1355
1356# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1357%_jvmdatadir %{_datadir}/jvm
1358
1359# Root directory for all configurations parts of Java VM/SDK/JRE's
1360%_jvmsysconfdir %{_sysconfdir}/jvm
1361
1362# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
1363%_jvmcommonlibdir %{_libdir}/jvm-common
1364
1365# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
1366%_jvmcommondatadir %{_datadir}/jvm-common
1367
1368# Root directory for all common configurations parts of Java VM/SDK/JRE's
1369%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
1370
1371# Directory where arch-specific (JNI) version-independent jars are installed.
1372%_jnidir %{_libdir}/java
1373
1374
1375# JDK selection. Set this to name of the JDK implementation to use
1376# insead of the system default
1377#%use_jdk icedtea6
1378
1379# expands to the value with right jdk for BuildRequires header
1380# 'jdk' if %%use_jdk is not defined, jdk(%%use_jdk) otherwise
1381# The requirement will not replace current 'default' JDK
1382%required_jdk jdk%{?use_jdk:(%{use_jdk})}
1383
1384%buildrequires_jdk BuildRequires: %required_jdk
1385
1386%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm}%{?use_jdk:JAVA_HOME=%{_jvmdir}/%{use_jdk}}; echo ${JAVA_HOME:-ERROR})}%java_home
1387
1388%_javasrcdir %{_usrsrc}/java
1389
1390%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
1391%jar %{java_home}/bin/jar
1392%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd}%{?use_jdk:JAVACMD=%{java_home}/bin/java}; echo $JAVACMD)}%java
1393%javac %{java_home}/bin/javac
1394%javadoc %{java_home}/bin/javadoc
1395
1396%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
1397
1398%jpackage_script() \
1399install -d $RPM_BUILD_ROOT%{_bindir}\
1400cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1401#!/bin/sh\
1402#\
1403# %{name} script\
1404# JPackage Project <http://www.jpackage.org/>\
1405\
1406# Source functions library\
1407. %{_javadir}-utils/java-functions\
1408\
1409# Source system prefs\
1410if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1411 . %{_sysconfdir}/java/%{name}.conf\
1412fi\
1413\
1414# Source user prefs\
1415if [ -f $HOME/.%{name}rc ]; then\
1416 . $HOME/.%{name}rc\
1417fi\
1418\
1419# Configuration\
1420MAIN_CLASS=%1\
1421BASE_FLAGS=%2\
1422BASE_OPTIONS=%3\
1423BASE_JARS="%(echo %4 | tr ':' ' ')"\
1424\
1425# Set parameters\
1426set_jvm\
1427set_classpath $BASE_JARS\
1428set_flags $BASE_FLAGS\
1429set_options $BASE_OPTIONS\
1430\
1431# Let's start\
1432run "$@"\
1433EOF
1434
1435# jpackage 1.7
1436# Directory for maven depmaps
1437#
1438%_mavendepmapdir /etc/maven
1439%_mavendepmapfragdir /etc/maven/fragments
1440
1441#
1442# add_to_depmap adds an entry to the depmap. The arguments are:
1443#
1444# %1 the original groupid
1445# %2 the original artifact id
1446# %3 the version
1447# %4 the new groupid
1448# %5 the new artifactid
1449#
1450
1451%add_to_maven_depmap() \
1452install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1453cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1454<dependency>\
1455 <maven>\
1456 <groupId>%1</groupId>\
1457 <artifactId>%2</artifactId>\
1458 <version>%3</version>\
1459 </maven>\
1460 <jpp>\
1461 <groupId>%4</groupId>\
1462 <artifactId>%5</artifactId>\
1463 <version>%3</version>\
1464 </jpp>\
1465</dependency>\
1466\
1467EOF\
1468%{nil}
1469
1470#==============================================================================
1471#
1472# update_maven_depmap updates the main maven depmap
1473#
1474%update_maven_depmap() \
1475echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1476if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1477cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1478fi\
1479echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1480
1481# JAVA macros specific for PLD
1482
1483# Directory for tomcat context configuration files
1484%_tomcatconfdir %{_sharedstatedir}/tomcat/conf/Catalina/localhost
1485
1486# Tomcat cache path
1487%_tomcatcachedir %{_sharedstatedir}/tomcat/work/Catalina/localhost
1488
1489# Clear tomcat cache
1490# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1491#
1492# Usage:
1493# %%tomcat_clear_cache appname
1494#
1495# Call this script in %postun scriptlet. It will remove compiled jsps related to
1496# given app.
1497#
1498%tomcat_clear_cache() %{!?1:ERROR}%{?2:ERROR} %{__rm} -rf %{_tomcatcachedir}/%1
1499
1500# PEAR install macros
1501# Author: Elan Ruusamäe <glen@pld-linux.org>
1502#
1503# Usage:
1504# %%pear_package_setup ...
1505#
1506# -a # - also unpack SOURCE#. for PEAR bootstrapping
1507# -n FMT - create builddir with FMT, instead of default %%{pearname}-%%{version}
1508# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1509# -D - pass -D to %setup (so the build dir is not removed)
1510# -c - register channel from local channel.xml file
1511# -d - pass -d arg to pearcmd
1512#
1513# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1514# destination hierarchy. you should copy the tree to buildroot after
1515# patching/reorganizing with %%pear_package_install.
1516#
1517# additionally BUILDROOT is stripped from files and files are converted to UNIX
1518# line endings.
1519#
1520# the pear install process output is recorded to install.log, you should put it
1521# to %%doc for later debug or just for information.
1522#
1523# additionally additional-packages.txt is produced if it was detected that the
1524# package has optional dependencies. the file format is suitable of displaying
1525# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1526# automatically added for this file.
1527
1528
1529# records install.log and transforms PEAR names to PLD Linux rpm package names.
1530%__pear_install_log \
1531tee install.log \
1532# make post message of optional packages \
1533grep -E 'can optionally use|Optional feature' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,' > optional-packages.txt \
1534if [ -s optional-packages.txt ]; then \
1535 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1536else \
1537 rm -f optional-packages.txt \
1538fi \
1539%{nil}
1540
1541# Command invoking PEAR CLI
1542# Same as /usr/bin/pear, except we force GMT timezone
1543%__pear %__php -doutput_buffering=1 -dopen_basedir="" -dmemory_limit=-1 -ddate.timezone=GMT /usr/share/pear/pearcmd.php
1544
1545%pear_install(a:d:n:zD) \
1546%__pear \\\
1547 -c %{builddir}/pearrc \\\
1548 -d doc_dir=/docs \\\
1549 -d temp_dir=/tmp \\\
1550 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
1551 -d bin_dir=%{_bindir} \\\
1552 -d data_dir=%{php_pear_dir}/data \\\
1553 -d test_dir=%{php_pear_dir}/tests \\\
1554 %{-d:%(echo "%{-d*}" | awk 'BEGIN{RS=","}{printf("-d %%s \\\\\\n\\t", $1)}')} \\\
1555 install \\\
1556 --packagingroot=%{builddir} \\\
1557 --offline \\\
1558 --nodeps \\\
1559 %{-f:--force} \\\
1560 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1561 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
1562%{nil}
1563
1564# The main macro.
1565# using this macro will append optional-packages.txt to the nocompressdoc list
1566# as it's displayed to user after package install. and adding additional gzip
1567# dep is just waste ;)
1568%pear_package_setup(a:d:n:zDc:) \
1569%define srcdir %{-n*}%{!-n:%{?_pearname}%{!?_pearname:%{pearname}}-%{version}} \
1570%define builddir %{_builddir}/%{srcdir} \
1571%setup -q -c -T %{-D:-D} -n %{srcdir} \
1572%{-z:%{__tar} zxf %{S:0}; %{-a:%{__tar} zxf %{S:%{-a*}}}} \
1573%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1574%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
1575%pear_install \
1576%{-z:cd ..} \
1577%{__tar} --wildcards -zvxf %{S:0} package*.xml \
1578cat %{-z:$_N/}.install.log | %__pear_install_log \
1579%undos -f php,html,js,xml \
1580%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1581%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1582%{nil}
1583
1584# Copies extracted PEAR package structure and PEAR registry to buildroot.
1585# Author: Elan Ruusamäe <glen@pld-linux.org>
1586%pear_package_install() \
1587cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1588# tests should not be packaged \
1589%{__rm} -rf $RPM_BUILD_ROOT%{php_pear_dir}/tests \
1590# cleanup backups \
1591find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1592# help the developer out a little: \
1593if [ -f _noautoreq ]; then \
1594 echo "AutoReqdep detected:" \
1595 echo "_noautoreq $(cat _noautoreq)" \
1596fi \
1597%{nil}
1598
1599# Print optional package info for pear packages
1600# Author: Elan Ruusamäe <glen@pld-linux.org>
1601# Usage:
1602# %post -p <lua>
1603# %%pear_package_print_optionalpackages
1604#
1605# Requirements:
1606# BuildRequires: rpmbuild(macros) >= 1.571
1607%pear_package_print_optionalpackages \
1608f = io.open("%{_docdir}/%{name}-%{version}/optional-packages.txt", "r") \
1609if f then \
1610 for l in f:lines() do print(l); end \
1611 f:close() \
1612end \
1613%{nil}
1614
1615
1616# Register OpenLDAP schema.
1617# Author: Elan Ruusamäe <glen@pld-linux.org>
1618#
1619# Usage:
1620# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1621#
1622# -d specify dependant schemas, separated by comma
1623#
1624%openldap_schema_register(d:) \
1625for schema in %*; do \
1626 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1627 %{__sed} -i -e " \
1628 /^include.*local.schema/{ \
1629 iinclude\\t $schema\
1630 } \
1631 " /etc/openldap/slapd.conf \
1632 fi \
1633done \
1634# enable dependant schemas \
1635if [ "%{-d*}" ]; then \
1636 %{__sed} -i -e ' \
1637 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1638 s/^#// \
1639 }' /etc/openldap/slapd.conf \
1640fi \
1641%{nil}
1642
1643# Unregister OpenLDAP schema.
1644# Author: Elan Ruusamäe <glen@pld-linux.org>
1645#
1646# Usage:
1647# %%openldap_schema_unregister %{schemadir}/horde.schema
1648#
1649%openldap_schema_unregister() \
1650for schema in %*; do \
1651 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1652 %{__sed} -i -e " \
1653 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1654 # for symmetry it would be nice if we disable enabled schemas in post, \
1655 # but we really can not do that, it would break something else. \
1656 " /etc/openldap/slapd.conf \
1657 fi \
1658done \
1659%{nil}
1660
1661%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1662
1663
1664# Build modules for kernels 2.6
1665# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1666#
1667# Usage:
1668# %build_kernel_modules -m <modules> -C <directory>
1669#
1670# remember that proper Makefile is still required
1671# Options:
1672# -m <modules> (required) -- comma-separated list of modules to save,
1673# without .ko extension, may be placed in subdirectory
1674# -C <directory> -- change to <directory> before doing anything
1675# -p <arg>, -P <arg> -- arguments passeed to make scripts
1676# -c -- do not execute make clean
1677# <additional arguments> -- all additional arguments will be passed to
1678# make modules
1679#
1680# Additional patching supported via here document. Try:
1681# %build_kernel_modules -m module <<'EOF'
1682# your patch script here
1683# EOF
1684# Don't use it unless patching depends on config options.
1685
1686# Developer note: don't touch it unless you know how to handle '\'.
1687# - \ in script expands to nothing
1688# - \\\ in script expands to \
1689# - \\\ inside definition expands to nothing
1690# - \\\\\\\ inside definition expands to \
1691# - in last line \ has to touch arguments so arguments passing
1692# in new lines (using \) will be supported
1693
1694%build_kernel_modules(p:P:m:C:c) \
1695%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1696 \
1697%define Opts \\\\\\\
1698%if "%{_target_base_arch}" != "%{_host_base_arch}" \\\
1699 %if "%{_host_base_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
1700 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
1701 %else \\\
1702 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1703 %endif \\\
1704%else \\\
1705 CC="%{kgcc}" \\\
1706%endif \
1707%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1708 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1709 \
1710%{?-C:cd %{-C*}} \
1711compile() { \
1712 local L="<" PATCH_SH; \
1713 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
1714 set -e -x \
1715 \
1716 [ -r "%{_kernelsrcdir}/.config" ] || exit 1 \
1717 rm -rf o \
1718 install -d o/include/linux o/include/generated o/arch/x86/include o/arch/powerpc/lib \
1719 ln -sf %{_kernelsrcdir}/.config o/.config \
1720 ln -sf %{_kernelsrcdir}/Module.symvers o/Module.symvers \
1721 if [ -f %{_kernelsrcdir}/include/generated/autoconf.h ]; then \
1722 ln -sf %{_kernelsrcdir}/include/generated/autoconf.h o/include/generated/autoconf.h \
1723 ln -s ../generated/autoconf.h o/include/linux/autoconf.h \
1724 else \
1725 ln -sf %{_kernelsrcdir}/include/linux/autoconf.h o/include/linux/autoconf.h \
1726 fi \
1727 if [ -d %{_kernelsrcdir}/arch/x86/include/generated ]; then \
1728 ln -s %{_kernelsrcdir}/arch/x86/include/generated o/arch/x86/include \
1729 fi \
1730 \
1731 set +x \
1732 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1733 set -x \
1734 \
1735 install -d o/include/config \
1736 touch o/include/config/MARKER \
1737 ln -sf %{_kernelsrcdir}/include/config/auto.conf o/include/config/auto.conf \
1738 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1739 \
1740 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
1741 RCS_FIND_IGNORE="-name '*.[ks]o' -o" \\\
1742 ${1+"$@"} \\\
1743 M=$PWD %{MakeOpts}} \
1744 \
1745 %{__make} -C %{_kernelsrcdir} modules \\\
1746 ${1+"$@"} \\\
1747 M=$PWD CONSTIFY_PLUGIN="" %{MakeOpts} \
1748%{?-C:cd -} \
1749} \
1750compile_old() { \
1751 local L="<" PATCH_SH; \
1752 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
1753 set -e -x \
1754 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1755 \
1756for cfg in ${cfgs:-dist}; do \
1757 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1758 \
1759 rm -rf o \
1760 install -d o/include/linux o/include/generated o/arch/powerpc/lib \
1761 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1762 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1763 if [ -f %{_kernelsrcdir}/include/generated/autoconf-$cfg.h ]; then \
1764 ln -sf %{_kernelsrcdir}/include/generated/autoconf-$cfg.h o/include/generated/autoconf.h \
1765 ln -s ../generated/autoconf.h o/include/linux/autoconf.h \
1766 else \
1767 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1768 fi \
1769 \
1770 set +x \
1771 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1772 set -x \
1773 \
1774 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
1775 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1776 %{-p*} %{-P*} \\\
1777 %{MakeOpts} \
1778 %else \
1779 install -d o/include/config \
1780 touch o/include/config/MARKER \
1781 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
1782 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1783 %endif \
1784 \
1785 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
1786 RCS_FIND_IGNORE="-name '*.[ks]o' -o" \\\
1787 ${1+"$@"} \\\
1788 M=$PWD %{MakeOpts}} \
1789 \
1790 %{__make} -C %{_kernelsrcdir} modules \\\
1791 ${1+"$@"} \\\
1792 M=$PWD CONSTIFY_PLUGIN="" %{MakeOpts} \
1793 \
1794 for MODULE in {%{-m*},}; do \
1795 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1796 done \
1797done \
1798%{?-C:cd -} \
1799} \
1800if [ -r "%{_kernelsrcdir}/.config" ]; then \
1801 compile %{*} \
1802else \
1803 compile_old %{*} \
1804fi \
1805%{nil}
1806
1807
1808# Install kernel modules built by %build_kernel_modules
1809# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1810#
1811# Usage:
1812# %install_kernel_modules -m <modules> -d <directory>
1813#
1814# Options:
1815# -m <modules> (required) -- comma-separated list of modules to install,
1816# without .ko extension, may be placed in subdirectory
1817# -d <directory> (required) -- in what subdirectory modules should be
1818# installed (eg. misc, kernel/drivers/net)
1819# -s <suffix> -- suffix to use when installing modules, useful when module
1820# with same name exists in kernel already
1821# -n <file> -- name of modprobe config file to use (without .conf extension)
1822# for defining aliases, only useful with -s
1823
1824%install_kernel_modules(m:d:s:n:) \
1825%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1826%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1827%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1828 \
1829%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1830%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1831 \
1832__install_kernel_modules() { \
1833%{!?debug:set +x;} \
1834 \
1835for MODULE in {%{-m*},}; do \
1836 [ -n "${MODULE}" ] || continue \
1837 MNAME=${MODULE##*/} \
1838 install -m 644 -D ${MODULE}.ko %{KernelD}/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
1839 %{?-s:install -d %{ModprobeD} \
1840 echo "alias ${MNAME} ${MNAME}-%{-s*}" >> %{ModprobeD}/%{-n*}.conf} \
1841done \
1842} \
1843__install_kernel_modules_old() { \
1844%{!?debug:set +x;} \
1845local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1846 \
1847for MODULE in {%{-m*},}; do \
1848 [ -n "${MODULE}" ] || continue \
1849 for cfg in ${cfgs:-dist}; do \
1850 [ "$cfg" = smp ] && suf=smp || suf= \
1851 MNAME=${MODULE##*/} \
1852 install -m 644 -D ${MODULE}-$cfg.ko \\\
1853 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
1854 %{?-s:install -d %{ModprobeD}$suf \
1855 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1856 >> %{ModprobeD}$suf/%{-n*}.conf} \
1857 done \
1858done \
1859} \
1860if [ -r "%{_kernelsrcdir}/.config" ]; then \
1861 __install_kernel_modules \
1862else \
1863 __install_kernel_modules_old \
1864fi \
1865%{nil}
1866
1867# patchset macros
1868# Author: Elan Ruusamäe <glen@pld-linux.org>
1869#
1870# Usage:
1871# %patchset_source -f <seq(1) format> <start> [<end>]
1872# %patchset_patch <start> [<end>]
1873#
1874# If <end> is omited, it is assumed to be <start>.
1875#
1876# For example in preamble:
1877# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1878# and in %prep:
1879# %patchset_patch 33 44
1880
1881# generate SourceX urls from range START STOP
1882# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1883# The sources start from 10000
1884%patchset_source(f:b:) %(
1885 base=%{-b*}%{!-b*:10000};
1886 start=$(expr $base + %1);
1887 end=$(expr $base + %{?2}%{!?2:%{1}});
1888 # we need to call seq twice as it doesn't allow two formats
1889 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1890 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1891 paste %{tmpdir}/__ps{1,2};
1892 rm -f %{tmpdir}/__ps{1,2};
1893) \
1894%{nil}
1895
1896# apply sources from %patchset_source
1897# -p specify -pX for %patch line
1898# -b base offset: defaults to 10000
1899%patchset_patch(f:p:b:) %(
1900 base=%{-b*}%{!-b*:10000};
1901 start=$(expr $base + %1);
1902 end=$(expr $base + %{?2}%{!?2:%{1}});
1903 echo ": patchset_patch %1%{?2: to %2}";
1904 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1905) \
1906%{nil}
1907
1908# return EXPANDED source url N from current spec
1909%sourceurl(n:) %(test "$IN_RPM" = 1 && exit 1; export IN_RPM=1; rpmbuild --nodigest --nosignature --nobuild -D "prep %%dump" %{_specdir}/%{name}.spec 2>&1 | awk '$2 ~ /^SOURCEURL%{-n*}/ {print $3}')
1910
1911# browser plugins v2
1912# Author: Elan Ruusamäe <glen@pld-linux.org>
1913#
1914# Usage:
1915# %browser_plugins_add_browser <name> -p <plugindir>
1916#
1917# <name> (required) -- name of the browser. usually %{name}.
1918# -p <plugindir> (required) -- in what directory browser searches for its plugins.
1919# -b -- default blacklists
1920# -a <arch> override arch
1921#
1922# Example:
1923# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1924
1925%_browserpluginsconfdir /etc/browser-plugins
1926%_browserpluginsdir %{_libdir}/browser-plugins
1927%update_browser_plugins /usr/sbin/update-browser-plugins || :
1928
1929%browser_plugins_add_browser(p:b:a:) \
1930 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1931 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1932 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1933 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1934 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1935 %{-b:cat >> $blacklist_file %{-b*}} \
1936%{nil}
1937
1938# Helper for LUA.
1939# split string separated by space into quoted list
1940#
1941# Author: Elan Ruusamäe <glen@pld-linux.org>
1942#
1943# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1944%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1945
1946# adjust /etc/shells by adding and removing shells from there
1947# Author: Elan Ruusamäe <glen@pld-linux.org>
1948#
1949# Usage:
1950# %post -p <lua>
1951# %lua_add_etc_shells /bin/sh /bin/pdksh
1952#
1953# %preun -p <lua>
1954# if arg[2] == 0 then
1955# %lua_remove_etc_shells /bin/bash /bin/rbash
1956# end
1957#
1958# Requirements:
1959# BuildRequires: rpmbuild(macros) >= 1.462
1960#
1961
1962%lua_add_etc_shells() \
1963t = {}\
1964f = io.open("/etc/shells", "r")\
1965if f then\
1966 for l in f:lines() do t[l]=l; end\
1967 f:close()\
1968end\
1969for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1970 if not t[s] then\
1971 print("Adding "..s.." to /etc/shells")\
1972 f = io.open("/etc/shells", "a")\
1973 if f then\
1974 f:write(s.."\\n")\
1975 f:close()\
1976 end\
1977 end\
1978end\
1979%{nil}
1980
1981%lua_remove_etc_shells() \
1982t = {}\
1983f = io.open("/etc/shells", "r")\
1984if f then\
1985 for l in f:lines() do t[l]=l; end\
1986 f:close()\
1987end\
1988for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1989 print("Removing "..l.." from /etc/shells")\
1990 t[l] = nil\
1991end\
1992s=""\
1993for _, l in pairs(t) do\
1994 s=s..l.."\\n"\
1995end\
1996f = io.open("/etc/shells", "w")\
1997if f then\
1998 f:write(s)\
1999 f:close()\
2000end\
2001%{nil}
2002
2003# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
2004#
2005# Author: Elan Ruusamäe <glen@pld-linux.org>
2006#
2007# Usage:
2008# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
2009# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
2010#
2011# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
2012#
2013# Requirements:
2014# BuildRequires: rpmbuild(macros) >= 1.429
2015#
2016%add_etc_shells(p) %{-p:<lua>}\
2017%{expand:%%lua_add_etc_shells %*}\
2018%{nil}
2019
2020%remove_etc_shells(p) %{-p:<lua>}\
2021%{-p:if arg[2] == 0 then}\
2022%{expand:%%lua_remove_etc_shells %*}\
2023%{-p:end} \
2024%{nil}
2025
2026# Check syntax for Python files
2027#
2028# Author: Elan Ruusamäe <glen@pld-linux.org>
2029# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
2030#
2031# Usage:
2032# %py_lint src
2033#
2034# Requirements:
2035# BuildRequires: python
2036# BuildRequires: rpmbuild(macros) >= 1.602
2037
2038%py_lint() \
2039__py_lint() { \
2040%{!?debug:set +x;} \
2041find "$@" -type f -name '*.py' | python -c ' \
2042import sys \
2043import compiler \
2044\
2045found = err = 0\
2046for f in sys.stdin: \
2047 fd = open(f.rstrip()) \
2048 c = fd.read() \
2049 fd.close() \
2050 found = found + 1 \
2051 try: \
2052 compiler.parse(c) \
2053 except SyntaxError, e: \
2054 print "py_lint: %s: %s" % (f.rstrip(), e) \
2055 err = err + 1\
2056\
2057if not found:\
2058 print >> sys.stderr, "\\npy_lint: ERROR: No files processed.\\n" \
2059 sys.exit(1) \
2060elif err: \
2061 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
2062 sys.exit(1) \
2063else: \
2064 print >> sys.stderr, "py_lint: %d files scanned, found no syntax errors." % found \
2065' \
2066}; __py_lint %* \
2067%{nil}
2068
2069# Undos files
2070#
2071# Author: Paweł Zuzelski <pawelz@pld-linux.org>
2072# Author: Elan Ruusamäe <glen@pld-linux.org>
2073#
2074# Usage:
2075# %undos list_of_files
2076# %undos -f EXT[,EXT]
2077# %undos -i -f EXT[,EXT]
2078#
2079# -f EXT[,EXT] - find(1) files by extensions
2080# -i - case insensitive file search
2081#
2082# Example:
2083# Un-DOS all *.js, *.css files
2084# %undos -f js,css
2085# Un-DOS all *.js, *.JS files
2086# %undos -f js -i
2087# undos all Makefiles
2088# %{__find} -name Makefile | xargs %undos
2089#
2090# Requirements:
2091# BuildRequires: sed >= 4.0
2092# BuildRequires: rpmbuild(macros) >= 1.565
2093
2094# NB: make sure this macro stays on one line
2095# NB: make sure it includes newline escape
2096%undos(f:i) %{-f:%{__find} -regextype posix-extended -%{-i:i}regex '^.+\\.(%(echo %{-f*} | tr ',' '|'))$' -print0 | xargs -0} %{__sed} -i -e 's,\\r$,,' %* \
2097%{nil}
2098
2099# Hook to register nagios object based plugins in Nagios NRPE daemon config.
2100#
2101# Author: Elan Ruusamäe <glen@pld-linux.org>
2102#
2103# Usage:
2104# -a NAME -- add command named NAME
2105# -d NAME -- remove command named NAME
2106# -f FILE -- specify plugin configuration FILE to extract command definition from
2107#
2108# Sample:
2109# %triggerin -- nagios-nrpe
2110# %nagios_nrpe -a %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
2111#
2112# %triggerun -- nagios-nrpe
2113# %nagios_nrpe -d %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
2114#
2115# Requirements:
2116# Requires: grep
2117# Requires: sed >= 4.0
2118# BuildRequires: rpmbuild(macros) >= 1.552
2119%nagios_nrpe(a:d:c:f:) {\
2120 m=$(md5sum < /etc/nagios/nrpe.cfg); \
2121 %{-a:# on -a and config exists \
2122 if [ -f /etc/nagios/nrpe.cfg ]; then \
2123 if ! %{__grep} -q '^command\[%{-a*}\]' /etc/nagios/nrpe.cfg; then \
2124 %{__sed} -ne 's/^[ \t]*command_line[ \t]\+\(.\+\)/command[%{-a*}]=\1/p' %{-f*} >> /etc/nagios/nrpe.cfg; \
2125 fi; \
2126 fi;} \
2127 %{-d:# on package remove, -d and config exists \
2128 if [ "$1" = "0" -a -f /etc/nagios/nrpe.cfg ]; then \
2129 %{__sed} -i -e '/^[ \t]*command\[%{-d*}\]/d' /etc/nagios/nrpe.cfg; \
2130 fi;} \
2131 if [ "$m" != "$(md5sum < /etc/nagios/nrpe.cfg)" ]; then \
2132 %service -q nrpe restart; \
2133 fi; \
2134}%{nil}
2135
2136# Import or update Cacti template.
2137#
2138# Author: Elan Ruusamäe <glen@pld-linux.org>
2139#
2140# Usage:
2141# %cacti_import_template XMLFILE
2142# XMLFILE -- XML template to import
2143#
2144# Sample:
2145# %post
2146# %cacti_import_template %{resourcedir}/cacti_host_template_varnish.xml
2147#
2148# Requires: cacti >= 0.8.7e-8
2149# BuildRequires: rpmbuild(macros) >= 1.630
2150# Note: 1.1 (cacti-0.8.7h) adds requirement for --with-template-rras or --with-user-rras option
2151
2152%cacti_import_template() {\
2153v=$(%{__sed} -rne 's/.+Add Graphs Script ([0-9\.]+).+/\1/p' /usr/share/cacti/cli/import_template.php); \
2154if [ "$v" != "1.0" ]; then \
2155 rra="--with-template-rras"; \
2156fi; \
2157/usr/share/cacti/cli/import_template.php --filename=%1 $rra || :; \
2158}%{nil}
2159
2160# pre/post script for -upstart subpackages
2161#
2162# Author: Jacek Konieczny <jajcus@jajcus.net>
2163#
2164# Usage:
2165# %upstart_post service_name
2166# %upstart_postun service_name
2167#
2168# Sample:
2169# %post upstart
2170# %upstart_post %{name}
2171#
2172# %postun upstart
2173# %upstart_postun %{name}
2174#
2175# Requirements:
2176# BuildRequires: rpmbuild(macros) >= 1.560
2177# Requires: rc-scripts >= 0.4.3
2178
2179# migrate from init script to upstart job
2180%upstart_post() \
2181 if [ -f /var/lock/subsys/%1 ]; then \
2182 /sbin/service --no-upstart %1 stop \
2183 /sbin/service %1 start \
2184 fi
2185
2186# restart the job after upgrade or migrate to init script on removal
2187# cannot be stopped with 'service' as /etc/init/$name.conf may be missing
2188# at this point
2189%upstart_postun() \
2190 if [ -x /sbin/initctl ] && /sbin/initctl status %1 2>/dev/null | grep -q 'running' ; then \
2191 /sbin/initctl stop %1 >/dev/null 2>&1 \
2192 [ -f /etc/rc.d/init.d/%1 -o -f /etc/init/%1.conf ] && { echo -n "Re-"; /sbin/service %1 start; }; \
2193 fi
2194
2195# Haskell Macros
2196# BuildRequires: rpmbuild(macros) >= 1.608
2197%ghcdir ghc-%(/usr/bin/ghc --numeric-version 2>/dev/null || echo ERROR)
2198
2199# update /usr/lib*/ghc-*/package.conf.d/package.cache
2200# Requires: ghc
2201# BuildRequires: rpmbuild(macros) >= 1.607
2202#
2203%ghc_pkg_recache() {{ \
2204 umask 022; \
2205 [ ! -x /usr/bin/ghc-pkg ] || /usr/bin/ghc-pkg recache; \
2206};} \
2207%{nil}
2208
2209
2210# pre/post script for packages supporting systemd units
2211#
2212# Author: Bartlomiej Zimon <uzi18@o2.pl>
2213# Jan Rękorajski <baggins@mimuw.edu.pl>
2214#
2215# Usage:
2216# %systemd_reload
2217# %systemd_service <unit command> service_name1.service service_name2.service
2218# %systemd_service_enable service_name1.service service_name2.service
2219# %systemd_service_disable service_name1.service service_name2.service
2220# %systemd_service_start service_name1.service service_name2.service
2221# %systemd_service_stop service_name1.service service_name2.service
2222# %systemd_service_restart service_name1.service service_name2.service
2223# %systemd_service_reload service_name1.service service_name2.service
2224#
2225# %systemd_post service_name1.service service_name2.service
2226# %systemd_preun service_name1.service service_name2.service
2227# %systemd_trigger service_name1.service service_name2.service
2228#
2229# Sample:
2230# %post
2231# %systemd_post %{name}.service
2232#
2233# %preun
2234# %systemd_preun %{name}.service
2235#
2236# %postun
2237# %systemd_reload
2238#
2239# %triggerpostun -- %{name} < first-version-with-systemd-units
2240# %systemd_trigger %{name}.service
2241#
2242# Requirements:
2243# BuildRequires: rpmbuild(macros) >= 1.647
2244# Requires: systemd-units >= 38
2245
2246%systemd_reload /bin/systemd_booted && SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog /bin/systemctl --quiet daemon-reload || :
2247
2248%systemd_service_enable() \
2249 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2250 /bin/systemctl --quiet enable %{*} || : \
2251 /bin/systemd_booted && echo 'Run "/bin/systemctl start %{*}" to start %{*}.' || : \
2252%{nil}
2253
2254%systemd_service_disable() \
2255 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2256 /bin/systemctl --quiet disable %{*} || : \
2257%{nil}
2258
2259%systemd_service() \
2260 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2261 /bin/systemd_booted && /bin/systemctl --quiet %{*} || : \
2262%{nil}
2263
2264%systemd_service_start() \
2265 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2266 /bin/systemd_booted && /bin/systemctl --quiet start %{*} || : \
2267%{nil}
2268
2269%systemd_service_stop() \
2270 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2271 /bin/systemd_booted && /bin/systemctl --quiet stop %{*} || : \
2272%{nil}
2273
2274%systemd_service_restart() \
2275 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2276 /bin/systemd_booted && /bin/systemctl --quiet try-restart %{*} || : \
2277%{nil}
2278
2279%systemd_service_reload() \
2280 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2281 /bin/systemd_booted && /bin/systemctl --quiet reload %{*} || : \
2282%{nil}
2283
2284%systemd_trigger() \
2285want_enable_service() { \
2286 [ -f /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
2287 [ ${RPM_ENABLE_SYSTEMD_SERVICE:-yes} = no ] && return 1 \
2288 /sbin/chkconfig --list ${1%.service} 2>/dev/null | grep -qsv "[0-6]:on" && return 1 \
2289 return 0 \
2290}\
2291 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2292 for s in %{*}; do \
2293 if want_enable_service $s; then \
2294 /bin/systemctl --quiet enable $s || : \
2295 fi \
2296 done \
2297%{nil}
2298
2299%systemd_post() \
2300 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2301 /bin/systemd_booted && /bin/systemctl --quiet daemon-reload || : \
2302 if [ $1 -eq 1 ]; then \
2303 /bin/systemctl --quiet enable %{*} || : \
2304 /bin/systemd_booted && echo 'Run "/bin/systemctl start %{*}" to start %{*}.' || : \
2305 elif [ -z "$NORESTART" ]; then \
2306 /bin/systemd_booted && /bin/systemctl --quiet try-restart %{*} || : \
2307 else \
2308 /bin/systemd_booted && echo 'Run "/bin/systemctl restart %{*}" to restart %{*}.' || : \
2309 fi \
2310%{nil}
2311
2312%systemd_preun() \
2313 if [ $1 -eq 0 ]; then \
2314 export SYSTEMD_LOG_LEVEL=warning SYSTEMD_LOG_TARGET=syslog \
2315 /bin/systemd_booted && /bin/systemctl --quiet stop %{*} || : \
2316 /bin/systemctl --quiet disable %{*} || : \
2317 fi \
2318%{nil}
2319
2320%systemdunitdir /lib/systemd/system
2321%systemdtmpfilesdir /usr/lib/tmpfiles.d
2322
2323# EOF
This page took 0.049596 seconds and 4 git commands to generate.